<?php
/**
 * @version		2.0
 * @package		Joomla
 * @subpackage	Joomla Donation
 * @author  Tuan Pham Ngoc
 * @copyright	Ossolution Team
 * @license		Commercial
 */
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );
jimport( 'joomla.application.component.controller' );
/**

 * Joom Donation controller

 * @package		Joomla

 * @subpackage	Joom Donation

 * @since 1.5

 */
class JDonationController extends JController
{
	/**
	 * Constructor function
	 *
	 * @param array $config
	 */
	function __construct($config = array())
	{
		parent::__construct($config);	
	}
	/**
	 * Display information
	 *
	 */
	function display( )
	{				
		$task = $this->getTask();
		$document = & JFactory::getDocument();
		$styleUrl = JURI::root().'components/com_jdonation/css/style.css';		
		$document->addStylesheet( $styleUrl, 'text/css', null, null );	
		switch ($task) {
			case 'donation_form' :
				JRequest::setVar('view', 'donation') ;		
				JRequest::setVar('layout', 'default') ;		
				break ;								
			case 'cancel':
				JRequest::setVar('view', 'cancel');
				break;
			case 'return':
				JRequest::setVar('view', 'complete');
				break;		
			default:
				//JRequest::setVar('view', 'types');
				break ;		
		}		
		$document = & JFactory::getDocument();
		$viewName	= JRequest::getVar('view', '');
		$viewType	= $document->getType();
		$model = & $this->getModel('jdonation');		
		$view = & $this->getView($viewName, $viewType);
		$view->setModel($model, true);		
		parent::display();
	}
	/**
	 * Process onetime donation
	 *
	 */
	function process_donation() {
		$model = & $this->getModel();
		$post = JRequest::get('post');	
		$amount = (float)$post['amount'];
		if ($amount <=0 )
			$post['amount'] = $post['rd_amount'];								
		$model->processDonation($post);
		$paymentMethod = $post['payment_method'];
		if ($paymentMethod == 'os_authnet') {
			$this->display();				
		}
	}
	/**
	 * Process recurring donation
	 *
	 */
	function process_recurring_donation() {
		$model = & $this->getModel();
		$post = JRequest::get('post');	
		$amount = (float)$post['amount'];
		if ($amount <=0 )
			$post['amount'] = $post['rd_amount'];								
		$model->processRecurringDonation($post);
		$paymentMethod = $post['payment_method'];
		if ($paymentMethod == 'os_authnet') {
			$this->display();				
		}
	}
	/**
	 * Donation notification
	 *
	 */
	function donation_confirm() {						
		$model = & $this->getModel();				
		$model->donationConfirm();			
	}
	/**
	 * Process recurring donation
	 *
	 */
	function recurring_donation_confirm() {
		$model = & $this->getModel();
		$model->recurringDonationConfirm();
	}
	/**
	 * Donation cancel
	 *
	 */
	function cancel() {
		$post = $_REQUEST;
		$model = & $this->getModel();
		$model->deleteDonation($post);	
		$this->display();		
	}
}